﻿--To change--
wmshape = "arrow" 
showDate = true
pingnotice = true
pingchannel = ChatFrame1
questsize = 0.8
mapsize = 1
--To change--


--locals
local wname = "|cff3399FFw|rMmap|r"
local font = "FONTS\\FRIZQT__.ttf"

--Hide stuff
local stuff = {
    "MiniMapVoiceChatFrame",
    "MiniMapWorldMapButton",
    "MinimapBorderTop",
    "MinimapNorthTag",
    "MinimapZoomOut",
    "MinimapZoomIn",
    "MiniMapTracking",
    "MinimapBorder",
    "GameTimeFrame",
}
for i,v in pairs(stuff) do
  getglobal(v).Show = function() end
  getglobal(v):Hide()
end

--Minimap
local MiniFrame = CreateFrame("Button", "Minimap Mover", UIParent, "UIPanelButtonTemplate")
MiniFrame:SetHeight(15)
MiniFrame:SetWidth(150)
MiniFrame:SetText("Minimap")
MiniFrame:Hide()
MiniFrame:ClearAllPoints()
MiniFrame:SetPoint("TOPRIGHT", UIParent, -15, 0)
Minimap:SetScale(mapsize)
Minimap:ClearAllPoints()
Minimap:SetPoint("TOP", MiniFrame, "BOTTOM", 0,0)

--Ticket
local TickFrame = CreateFrame("Button", "Ticket Mover", UIParent, "UIPanelButtonTemplate")
TickFrame:SetHeight(15)
TickFrame:SetWidth(40)
TickFrame:SetText("Ticket")
TickFrame:Hide()
TickFrame:ClearAllPoints()
TickFrame:SetPoint("TOPRIGHT", UIParent, -165, 0)
TicketStatusFrame:ClearAllPoints()
TicketStatusFrame:SetPoint("TOP", TickFrame, "BOTTOM", 0,0)

--Durability
local DuraFrame = CreateFrame("Button", "Durability Mover", UIParent, "UIPanelButtonTemplate")
DuraFrame:SetHeight(15)
DuraFrame:SetWidth(60)
DuraFrame:SetText("Durability")
DuraFrame:Hide()
DuraFrame:ClearAllPoints()
DuraFrame:SetPoint("TOPRIGHT", UIParent, 0, -188)
hooksecurefunc(DurabilityFrame,"SetPoint",function(_,_,parent)
	if (parent == "MinimapCluster") or (parent == _G["MinimapCluster"]) then
DurabilityFrame:ClearAllPoints()
DurabilityFrame:SetPoint("TOP", DuraFrame, "BOTTOM", 0,0)
DurabilityFrame:Show()
	end
end)

--Quest
local QuestFrame = CreateFrame("Button", "Quest Mover", UIParent, "UIPanelButtonTemplate")
QuestFrame:SetHeight(20)
QuestFrame:SetWidth(150)
QuestFrame:SetText("Quest")
QuestFrame:Hide()
QuestFrame:ClearAllPoints()
QuestFrame:SetPoint("TOPRIGHT", UIParent, -80,-230)
hooksecurefunc(WatchFrame,"SetPoint",function(_,_,parent)
	if (parent == "MinimapCluster") or (parent == _G["MinimapCluster"]) then
WatchFrame:ClearAllPoints()
WatchFrame:SetPoint("TOPRIGHT",QuestFrame,"TOPRIGHT",0,0)
WatchFrame:SetPoint("BOTTOMRIGHT",QuestFrame,"BOTTOMRIGHT",0,-500)
WatchFrame:SetClampedToScreen(true)
WatchFrame:SetScale(questsize)
WatchFrame:SetHeight(500)
	end
end)

--Vehicle
local wmVehicleSeatFrame = CreateFrame("Button", "VehicleSeatButton", UIParent)
local VehFrame = CreateFrame("Button", "Vehicle Mover", UIParent, "UIPanelButtonTemplate")
VehFrame:SetHeight(20)
VehFrame:SetWidth(150)
VehFrame:SetText("Vehicle")
VehFrame:Hide()
VehFrame:ClearAllPoints()
VehFrame:SetPoint("TOPRIGHT", UIParent, -80, -188)
hooksecurefunc(VehicleSeatIndicator,"SetPoint",function(_,_,parent)
	if (parent == "MinimapCluster") or (parent == _G["MinimapCluster"]) then
VehicleSeatIndicator:ClearAllPoints()
VehicleSeatIndicator:SetPoint("TOP",VehFrame,"BOTTOM",0,0)
	end
end)

--MoveStuff

function wmmove(frame)
	frame:SetMovable(true)
	frame:SetClampedToScreen(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", frame.StartMoving)
	frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
end

wmmove(MiniFrame)
wmmove(TickFrame)
wmmove(DuraFrame)
wmmove(QuestFrame)
wmmove(VehFrame)

--MENUCOMMANDS]
function Getwmshape()
	return wmshape
end

local t = Minimap:CreateTexture(nil, 'ARTWORK')
t:SetPoint('TOPLEFT', Minimap, 'TOPLEFT', -12, 12)
t:SetPoint('BOTTOMRIGHT', Minimap, 'BOTTOMRIGHT', 12, -12)
t:SetBlendMode('BLEND')

local function CList(msg)
	msg = msg:lower()
	if msg == "reset" then
		MiniFrame:ClearAllPoints()
		MiniFrame:SetPoint("TOPRIGHT", UIParent, -15, 0)
                TickFrame:ClearAllPoints()
                TickFrame:SetPoint("TOPRIGHT", UIParent, -165, 0)
		DuraFrame:ClearAllPoints()
		DuraFrame:SetPoint("TOPRIGHT", UIParent, 0, -188)
		QuestFrame:ClearAllPoints()
		QuestFrame:SetPoint("TOPRIGHT", UIParent, -80,-230)
		VehFrame:ClearAllPoints()
		VehFrame:SetPoint("TOPRIGHT", UIParent, -80, -188)
                print(wname.."|cFF00FFFF: reset.|r")
	elseif msg == "rl" then
		ReloadUI()
	elseif msg == "unlock" then
                MiniFrame:Show()
                TickFrame:Show()
                DuraFrame:Show()
		VehFrame:Show()
		if WatchFrame:IsVisible() then QuestFrame:Show() end
                print(wname.."|cFF00FFFF: unlocked for drag.|r")
	elseif msg == "lock" then
		MiniFrame:Hide()
                TickFrame:Hide()
                DuraFrame:Hide()
		VehFrame:Hide()
		QuestFrame:Hide()
                print(wname.."|cFF00FFFF: locked.|r")
	elseif msg == "gold" or msg == "gloss" or msg == "arrow" or msg == "tec" then
		Minimap:SetMaskTexture([[Interface\AddOns\wMmap\texture\mask-]] .. msg)
		t:SetTexture([[Interface\AddOns\wMmap\texture\]] .. msg)
		print(wname.."|cFF00FFFF: Shape set to " .. msg .. ".|r")
	else
	print(wname..": Use Left Mouse Button to ping the minimap")
	print(wname..": Use Middle Mouse Button to open calander")
	print(wname..": Use Right Mouse Button to show tracking dropdown menu")
	print(wname..": Type |cffFF0000/wm unlock|r to move the Minimap")
	print(wname..": Type |cffFF0000/wm lock|r to lock the Minimap from moving")
	print(wname..": Type |cffFF0000/wm reset|r to set minimap to default position")
        print(wname..": Type |cffFF0000/wf|r Use Left Mouse Button to move Quest Frame, and to lock and unlock")
	print(wname..": Type |cFF00FFFF /shape shape here|r Change the shape. Example: |cFFFFFF00/shape gold|r or |cFFFFFF00/shape gloss|r or |cFFFFFF00/shape arrow|r or |cFFFFFF00/shape tec|r")
	print(wname..": Type |cffFF0000/wm rl|r to reload the ui")
	end
end

SLASH_CList1 = "/wm"
SlashCmdList["CList"] = CList

CList(wmshape)

--TextStuff
MinimapZoneTextButton:SetPoint("TOP", Minimap, "TOP", 0, 8)
MinimapZoneTextButton:SetFrameStrata("HIGH")
MinimapZoneText:SetFont(font, 10, "OUTLINE")

LoadAddOn('Blizzard_TimeManager')
local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
clockFrame:Hide()
clockTime:Show()
clockTime:SetFont(font, 14)
    if(CalendarGetNumPendingInvites() > 0) then
		clockTime:SetTextColor(0, 1, 0) -- Red
	else
		clockTime:SetTextColor(1, 1, 1) -- White
    end
TimeManagerClockButton:SetPoint("CENTER", Minimap, "BOTTOM", -2, 2)

if showDate then
	local fdate = CreateFrame("Frame", nil, UIParent)

	fdate.text = fdate:CreateFontString(nil, "BACKGROUND", "GameFontNormalSmall")
	fdate.text:SetPoint("TOP", Minimap, "BOTTOM", -3, -4)

	fdate:SetScript("OnUpdate", function()
		fdate.text:SetText(date("%a %d/%b"))
	end)
end

--Zoom
Minimap:SetZoom(0)
Minimap:EnableMouseWheel(true)
Minimap:SetScript("OnMouseWheel", function()
	if arg1 > 0 then Minimap_ZoomIn() else Minimap_ZoomOut() end
	end)
--SetClicks
Minimap:SetScript('OnMouseUp', function(self, button)
    if (button == 'RightButton') then
        ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, - (Minimap:GetWidth() * 0.7), -3)
    elseif (button == 'MiddleButton') then
        ToggleCalendar()
    else
        Minimap_OnClick(self)
    end
end)

--BATTLEGROUND
MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("TOP", Minimap, 0, -3)
MiniMapBattlefieldFrame:SetScale(.9)
MiniMapBattlefieldBorder:Hide()
--InstanceDifficulty
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", Minimap, 0, -4)
MiniMapInstanceDifficulty:SetScale(.9)
MiniMapInstanceDifficulty:SetFrameStrata("HIGH")
--LFGFRAME
function UpdateLFG()
MiniMapLFGFrame:ClearAllPoints()
MiniMapLFGFrame:SetPoint("BOTTOMRIGHT", Minimap, 3, -3)
MiniMapLFGFrame:SetScale(.9)
    LFDSearchStatus:ClearAllPoints()
    LFDSearchStatus:SetPoint("TOPRIGHT", MiniMapLFGFrame, 0, 130)
    LFDSearchStatus:SetScale(.8)
end
MiniMapLFGFrameBorder:SetAlpha(0)
DropDownList1:SetClampedToScreen(true)
hooksecurefunc("MiniMapLFG_UpdateIsShown", UpdateLFG)
--MAILFRAME
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint('BOTTOM', Minimap, 0, 18)
MiniMapMailFrame:SetHeight(10)
MiniMapMailBorder:Hide()
MiniMapMailIcon:SetTexture("Interface\\AddOns\\wMmap\\texture\\mail")


--Hook
Minimap:SetFrameStrata("BACKGROUND")
local ping = CreateFrame("frame")
ping:RegisterEvent("MINIMAP_PING")
ping:SetScript("OnEvent", function(self,event,unit) if pingnotice then local ping_name = UnitName(unit) pingchannel:AddMessage(wname.." pinged by: |cffFF0000" .. ping_name .. "|r") end end)
print(wname..": Loaded - |cff3399FF/wm|r for more information")